From d44b44f8b4b79c6fe875b755699ac8f158cef583 Mon Sep 17 00:00:00 2001
From: Gabriele Musco <gabmus@disroot.org>
Date: Sun, 26 Nov 2023 17:37:05 +0100
Subject: [PATCH 10/54] feat: boxed-list style for thermal stats

---
 lact-gui/src/app/root_stack/mod.rs            |  2 +
 .../src/app/root_stack/thermals_page/mod.rs   | 74 +++++++++++--------
 2 files changed, 44 insertions(+), 32 deletions(-)

diff --git a/lact-gui/src/app/root_stack/mod.rs b/lact-gui/src/app/root_stack/mod.rs
index ccb71474..f991b2fc 100644
--- a/lact-gui/src/app/root_stack/mod.rs
+++ b/lact-gui/src/app/root_stack/mod.rs
@@ -99,6 +99,8 @@ impl LabelRow {
         let label = Label::builder()
             .css_classes(["dim-label"])
             .ellipsize(pango::EllipsizeMode::End)
+            .xalign(1.0)
+            .justify(Justification::Right)
             .selectable(true)
             .build();
         container.add_suffix(&label);
diff --git a/lact-gui/src/app/root_stack/thermals_page/mod.rs b/lact-gui/src/app/root_stack/thermals_page/mod.rs
index 8741626c..c2482cae 100644
--- a/lact-gui/src/app/root_stack/thermals_page/mod.rs
+++ b/lact-gui/src/app/root_stack/thermals_page/mod.rs
@@ -1,13 +1,13 @@
 mod fan_curve_frame;
 
 use self::fan_curve_frame::FanCurveFrame;
-use super::{label_row, values_grid};
+use super::{list_clamp, LabelRow};
 use crate::app::page_section::PageSection;
 use glib::clone;
 use gtk::prelude::*;
 use gtk::*;
 use lact_client::schema::{default_fan_curve, DeviceStats, FanControlMode, FanCurveMap};
-use libadwaita::prelude::MessageDialogExt;
+use libadwaita::prelude::*;
 
 #[derive(Debug)]
 pub struct ThermalsSettings {
@@ -19,9 +19,9 @@ pub struct ThermalsSettings {
 
 #[derive(Clone)]
 pub struct ThermalsPage {
-    pub container: Box,
-    temperatures_label: Label,
-    fan_speed_label: Label,
+    pub container: ScrolledWindow,
+    temperatures_row: LabelRow,
+    fan_speed_row: LabelRow,
     fan_static_speed_adjustment: Adjustment,
     fan_curve_frame: FanCurveFrame,
     fan_control_mode_stack: Stack,
@@ -30,22 +30,27 @@ pub struct ThermalsPage {
 
 impl ThermalsPage {
     pub fn new(root_win: libadwaita::ApplicationWindow) -> Self {
-        let container = Box::builder()
+        let vbox = Box::builder()
             .orientation(Orientation::Vertical)
-            .spacing(15)
-            .margin_start(20)
-            .margin_end(20)
+            .spacing(12)
             .build();
 
         let stats_section = PageSection::new("Statistics");
-        let stats_grid = values_grid();
+        let stats_listbox = ListBox::builder()
+            .css_classes(["boxed-list"])
+            .selection_mode(SelectionMode::None)
+            .build();
+
+        let temperatures_row = LabelRow::new("Temperatures");
+
+        let fan_speed_row = LabelRow::new("Fan speed");
 
-        let temperatures_label = label_row("Temperatures:", &stats_grid, 0, 0, false);
-        let fan_speed_label = label_row("Fan speed:", &stats_grid, 1, 0, false);
+        stats_listbox.append(&temperatures_row.container);
+        stats_listbox.append(&fan_speed_row.container);
 
-        stats_section.append(&stats_grid);
+        stats_section.append(&stats_listbox);
 
-        container.append(&stats_section);
+        vbox.append(&stats_section);
 
         let fan_curve_frame = FanCurveFrame::new();
 
@@ -78,7 +83,7 @@ impl ThermalsPage {
         fan_control_section.append(&fan_control_mode_stack_switcher);
         fan_control_section.append(&fan_control_mode_stack);
 
-        container.append(&fan_control_section);
+        vbox.append(&fan_control_section);
 
         fan_control_mode_stack.connect_visible_child_name_notify(move |stack| {
             if stack.visible_child_name() == Some("automatic".into()) {
@@ -86,10 +91,15 @@ impl ThermalsPage {
             }
         });
 
+        let container = ScrolledWindow::builder()
+            .hscrollbar_policy(PolicyType::Never)
+            .child(&list_clamp(&vbox))
+            .build();
+
         Self {
             container,
-            temperatures_label,
-            fan_speed_label,
+            temperatures_row,
+            fan_speed_row,
             fan_static_speed_adjustment,
             fan_curve_frame,
             fan_control_mode_stack,
@@ -107,23 +117,23 @@ impl ThermalsPage {
         let temperatures_text = if temperatures.is_empty() {
             String::from("No sensors found")
         } else {
-            temperatures.join(", ")
+            temperatures.join(" | ")
         };
 
-        self.temperatures_label
-            .set_markup(&format!("<b>{temperatures_text}</b>",));
-
-        match stats.fan.speed_current {
-            Some(fan_speed_current) => self.fan_speed_label.set_markup(&format!(
-                "<b>{} RPM ({}%)</b>",
-                fan_speed_current,
-                (fan_speed_current as f64
-                    / stats.fan.speed_max.unwrap_or(fan_speed_current) as f64
-                    * 100.0)
-                    .round()
-            )),
-            None => self.fan_speed_label.set_text("No fan detected"),
-        }
+        self.temperatures_row.set_content(&temperatures_text);
+
+        self.fan_speed_row
+            .set_content(&match stats.fan.speed_current {
+                Some(fan_speed_current) => format!(
+                    "{} RPM ({}%)",
+                    fan_speed_current,
+                    (fan_speed_current as f64
+                        / stats.fan.speed_max.unwrap_or(fan_speed_current) as f64
+                        * 100.0)
+                        .round()
+                ),
+                None => "No fan detected".into(),
+            });
 
         if initial {
             self.fan_control_mode_stack_switcher.set_visible(true);

